     1  REM [HEX:\
76,76,18,02,00,00,3A,86,\
40,32,D4,40,3A,87,40,32,\
CC,40,CD,BB,02,2C,20,FA,\
CD,BB,02,2C,C0,06,01,CD,\
B0,40,06,03,CD,B0,40,06,\
05,CD,B0,40,18,EA,C5,CD,\
E9,40,C1,21,3E,40,16,00,\
5F,A7,CB,13,19,4E,CD,E2,\
40,05,23,4E,CD,E2,40,06,\
0D,0E,00,CD,E2,40,CD,E9,\
40,26,00,CB,47,28,03,A7,\
CB,1C,2B,7C,B5,20,FB,C9,\
78,D3,DF,79,D3,0F,C9,ED,\
5B,32,40,63,2E,FD,7A,B7,\
06,00,ED,52,98,ED,52,98,\
5F,50,ED,52,30,01,23,22,\
32,40,7D,E6,07,06,06,90,\
30,FD,80,3C,C9]
     5 GOTO VAL "9E3"
#===============================
#CHIMES LOOP
#===============================
    10 LET A=USR 16516
    20 IF USR RZ THEN REM RESET ZONX
    30 SLOW
    40 PRINT AT 21,0;D$
    50 IF INKEY$<>"" THEN GOTO 50
    60 GOTO 900
#===============================
#SET UP
# CLEAR ENVELOPE PERIOD, VOLUMN OFF
#===============================
   500 IF USR RZ THEN REM RESET ZONX
   510 PRINT AT 3,0;"\
WIND CHIMES BY GREG HARDER, 2025",,"\
        PENTATONIC SCALE",,,"\
      SEE SYNC NOV/DEC 83",,,"\
     BASE FREQUENCY EXAMPLES    \
  \
  CRYSTAL=1320",,"\
    GLASS= 660",,"\
  TUBULAR= 330",,"\
    BELLS= 160",,"\
    GONGS=  80",,"\
   ANVILS=  40",,"\
  ",,"\
 1 TO 8 PRINTS OCTAVE LIST."
   520 LET I$="BASE FREQUENCY?"
   530 GOSUB 3000
   540 IF N<1 THEN LET N=1
   550 IF N<9 THEN GOTO 2000
   560 PRINT AT 19,0;D$
   570 LET F=N
   700 CLS
   710 LET Y=0
   720 LET HL=16448
   730 PRINT "\
     WIND CHIME SIMULATOR     \
\
FREQ   C1    C0     OPTIONS  \
\
                    sTART    \
                    pERIOD   \
                    bONG     \
                    cHANNELS \
                    -------- \
                    nEW FREQ \
                    qUIT     \
\
C1=TONE FREQ COARSEPERIOD:   \
C0=TONE FREQ FINE    BONG:   \
";AT 4,0;
   740 FOR N=1 TO 6
   750  LET Y=Y+1
   760  LET Z=INT(F*P(N))
   770  LET X=INT(101562.5/Z)
   780  LET C1=INT(X/256)
   790  LET C0=X-256*C1
   800  PRINT TAB 1;Z;TAB 8;C1;TAB 14;C0
   810  POKE HL,C1
   820  LET HL=HL+1
   830  POKE HL,C0
   840  LET HL=HL+1
   850 NEXT N
   880 PRINT AT 12,28;"   ";AT 13,28;"   ";\
AT 12,28;EP;AT 13,28;BO
   900 PRINT AT 21,0;D$;AT 21,7;"SELECT AN OPTION."
   910 LET Z$=INKEY$
   920 IF Z$<"A" OR Z$>"T" THEN GOTO 910
#              abcdefghijklmnopqrs
#               vv vv       v vv v
   930 LET Z$="0280700000000501600"(CODE Z$-37)
   940 LET Z=CODE Z$-28
   960 GOTO 1000+100*Z
#===============================
#WIND CHIMES SETUP
# 1010:POKE BONG RATE
# ZONX SETUP
#   EP=ENV. PERIOD
# 1020:EP>0 ENV. CONTROL, EP=0 PURE TONE
#===============================
  1000 PRINT AT 21,0;D$;AT 21,4;"ANY KEY STOPS THE CHIMES."
  1010 POKE 16518,BO
  1020 LET N=16-(NOT EP)
  1030 PRINT USR ZNX;7,CH,8,N,9,N,10,N,11,00,12,EP
  1040 GOTO 10
#===============================
  1050 PRINT AT 18,0;"\
SLOWER BONG RATES REQUIRE LONGER\
PERIODS TO STOP DEAD AIR CLICKS."
  1060 RETURN
#===============================
#SET PERIOD
#===============================
  1100 PRINT AT 15,0;"\
THE PERIOD IS THE LENGTH OF TIME\
A CHIME RINGS. 0=PURE TONE.";
  1110 GOSUB 1050
  1120 LET I$="PERIOD?(<=250), LOWER=SHORTER."
  1130 GOSUB 3000
  1140 IF N>250 THEN LET N=250
  1150 LET EP=N
  1160 PRINT AT 15,0;D$;D$;D$;D$;D$;D$;D$
  1170 GOTO 880
#===============================
#SET BONG
#===============================
  1200 PRINT AT 15,0;"\
BONG RATE  DETERMINES HOW  OFTEN\
A CHIME IS RUNG."
  1210 GOSUB 1050
  1220 LET I$="\
BONG RATE?(<=250),LOWER=WINDIER."
  1230 GOSUB 3000
  1240 IF N<1 THEN LET N=1
  1250 IF N>250 THEN LET N=250
  1260 LET BO=N
  1270 GOTO 1170
#===============================
#NEW FREQ
#===============================
  1500 RUN
#===============================
#QUIT
#===============================
  1600 PRINT AT 21,0;D$;AT 21,9;"RUN TO RESTART";QQ
#===============================
#ENVELOPE SHAPE
#===============================
  1700 PRINT AT 15,0;"\
        ENVELOPE  SHAPES        \
 0-SINGLE DECAY   6-UP THEN OFF \
 8-SAWTOOTH      10-UP AND DOWN \
11-MIN THEN MAX  12-SAWTOOTH    \
13-RISE TO MAX   14-DOWN AND UP"
  1710 LET I$="ENVELOPE SHAPE?"
  1720 GOSUB 3000
  1730 POKE 16519,N
  1740 GOTO 1170
#===============================
#CHANNELS
#===============================
  1800 PRINT AT 16,0;"\
CHANNELS:0=A+B+C   1=B+C   2=A+C\
         3=C       4=A+B   5=B  \
         6=A       7=MUTE"
  1810 LET I$="CHANNELS?"
  1820 GOSUB 3000
  1830 LET CH=56+N
  1840 GOTO 1170
#===============================
#SCALES
#===============================
  2000 REM FAST
  2010 LET X=1+USR RZ
  2020 LET O=N-X
  2030 CLS
  2035 PRINT USR ZNX;7,60,8,15,9,15
  2040 PRINT "\
 OCTAVE:    ";AT 0,9;N;TAB 0;"\
",,"\
NOTE   FREQ ",,"\
";AT 16,0;"\
";AT 4,0;
  2050 FOR N=1 TO 12
  2060  LET NO=440*2**((N-10)/12)*2**O/8
  2070  PRINT " ";N$(X TO X+1);"     ";
  2080  LET X=X+2
  2090  LET A=6500000/64/NO
  2100  LET C1=INT (A/256)
  2110  LET C0=INT (A-(C1*256))
  2120  LET G=10**(4-INT (LN NO/2.))
  2130  LET N1=INT (INT (101562.5/(C0+(256*C1))*G)/G)
  2140  PRINT N1;\
("   ANVILS" AND N1=41);\
("   GONGS" AND N1=82);\
("   BELLS" AND N1=164);\
("   MIDDLE C" AND N1=261);\
("   TUBULAR BELLS" AND N1=329);\
("   GLASSY" AND N1=659);\
("   CRYSTALS" AND N1=1318);TAB 0;
  2150  PRINT USR ZNX;0,C0,1,C1,2,C0,3,C1
  2160 NEXT N
  2170 LET N=SIN SIN SIN SIN SIN SIN PI
  2180 IF USR RZ THEN REM RESET ZONX
  2190 GOTO 520
#===============================
#INPUT ROUTINE
#===============================
  3000 PRINT AT 21,0;D$;AT 21,0;I$
  3010 INPUT N
  3020 PRINT AT 21,0;D$;AT 0,0;
  3030 RETURN
#===============================
#INITIALIZE
#===============================
  9000 FAST
#Z$="PEEK 16425+256*PEEK 16426+9"
  9005 LET Z$="@D316425+256*@D316426+9"
#===============================
#ZONX:FEED DATA DIRECTLY TO AY CHIP
#
# PRINT USR ZNX;RX,DX,....
#  RX=REG
#  DX=DATA
#
#  IF RX=20 THEN PAUSE DX SHORT DELAY, 1 TO DX
#  IF RX=30 THEN PAUSE DX LONG DELAY,  1 TO DX01
#
# USR (ZNX+2)=RESET ZONX 
#===============================
  9010 LET ZNX=VAL Z$
  9015 REM zonx[HEX:\
18,02,18,2F,E7,CD,\
92,0D,E7,CD,92,0D,CD,F5,\
0B,79,FE,14,28,11,FE,15,\
28,12,D3,DF,78,D3,0F,DF,\
FD,BE,5C,20,E1,CF,FF,48,\
06,00,18,02,0E,01,0B,78,\
B1,20,FB,18,EA,06,0E,78,\
3D,D3,DF,AF,D3,0F,10,F7,\
3E,07,D3,DF,3E,3F,D3,0F,\
0E,00,C9]
#===============================
#  P=PENTATONIC RATIOS
# RZ=AY RESET MC ADDR, USR RZ
# EP=ENVELOPE PERIOD
# BO=BONG RATE
# CH=CHANNELS
# N$=NOTES
# D$=BLANK LINE$
# RESET ENVELOPE SHAPE
#===============================
  9020 DIM P(6)
  9021 LET P(1)=1/1
  9022 LET P(2)=9/8
  9023 LET P(3)=5/4
  9024 LET P(4)=3/2
  9025 LET P(5)=5/3
  9026 LET P(6)=2/1
  9090 CLS
  9100 LET RZ=ZNX+VAL "2"
  9110 LET EP=VAL "140"
  9120 LET BO=VAL "40"
  9130 LET CH=VAL "56"
  9140 LET N$="C C*D D*E F F*G G*A A*B "
  9150 DIM D$(VAL "32")
  9160 POKE 16519,NOT PI
  9500 SLOW
  9510 GOTO VAL "500"
#==================
  9990 SAVE "PENTA"
  9998 RUN